#include<bits/stdc++.h>

using namespace std;

const int maxn = 35;

int n, par[maxn];
vector < pair < int, int > > adj[maxn];
void build_graph()
{
    ///cout << "char " << (char)('-') << endl;
    string s;
    cin >> s;
    cout << s << endl;
    int num = 0, node = -1;
    int sign = 1;
    for (int i = 0; i < s.size(); i ++)
    {
        ///cout << "HERE " << s[i] << endl;
        char c = s[i];
        ///cout << c << endl;
        if (c == '(')
        {
            ++ n;
            par[n] = node;
            ///cout << "add to " << par[n] << " " << node
            if (par[n] != -1)
                adj[par[n]].push_back({num * sign, n});
            sign = 1;
            num = 0;
            node = n;
        }
        else
        if (c == ')')
        {
            if (num != 0)   
            {
                adj[node].push_back({num * sign, ++ n});
                par[n] = node;
                sign = 1;
                num = 0;
            }
            node = par[node];
        }
        else
        if (c == '-')
        {
            sign = -1;
        }
        else
        if (c >= '0' && c <= '9')
        {
            num = num * 10 + c - '0';
        }
        else
        if (c == ',')
        {
            ///cout << "add to " << node << " " << n + 1 << endl;
            if (num != 0)
            {
                adj[node].push_back({num * sign, ++ n});
                par[n] = node;
                sign = 1;
                num = 0;
            }
        }
        else
        {
            //cout << i << endl;
            //cout << c << endl;
            assert(false);
        
        
        }

        ///cout << "state " << s[i] << " " << node << " n: " << n << endl;
    }
}

void print_graph()
{
    cout << "Number of vertices: " << n << endl;
    for (int i = 1; i <= n; i ++)
    {
        cout << "Vertex: " << i << endl;
        for (pair < int, int > cur : adj[i])
        {
            cout << "Child: " << cur.second << " Arm: " << cur.first << endl;
        } 
    }
}

int cnt_leaves = 0;
int p[maxn], used[maxn];

int weight[maxn], rid[maxn];


bool dfs(int v)
{
    weight[v] = 0;
    if (adj[v].size() == 0)
    {
        weight[v] = p[rid[v]];
    }
    bool fine = true;
    int arm = 0;
    for (pair < int, int > nb : adj[v])
    {
        int u = nb.second;
        if (dfs(u) == false)
            fine = false;
        weight[v] += weight[u];
        arm = arm + nb.first * weight[u];
    }

    if (arm != 0)
        fine = false;
    return fine;


}

void print(int v)
{
    if (adj[v].size() > 0)
    {
        cout << '(';
        int last = - 1;
        for (pair < int, int > u : adj[v])
        {
            if (last != -1)
                cout << ',';
            print(u.second);
            last = 1;
        }
        cout << ')';
    }
    else
    {
        cout << weight[v];
    }
}
void check()
{
    if (dfs(1) == false)
        return;
    ///assert(false);
    print(1);
    ///cout << endl;
    exit(0);
}
void perm(int pos)
{
    if (pos > cnt_leaves)
        check();
    else
    {
        for (int i = 1; i <= cnt_leaves; i ++)
        {
            if (!used[i])
            {
                p[pos] = i;
                used[i] = 1;
                perm(pos + 1);
                used[i] = 0;
                p[pos] = 0;
            }
        }
    }
}
void simulate()
{
   
    for (int i = 1; i <= n; i ++)
        if (adj[i].size() == 0)
        {
            cnt_leaves ++;
            rid[i] = cnt_leaves;
        }

    perm(1);
}
void solve()
{
    build_graph();
    ///print_graph();
    ///assert(false);
    simulate();
    ///assert(false);
}
int main()
{
    ///freopen("test2.txt", "r", stdin);
    solve();
    return 0;
}
/**
(-3(-1(-1(-1,1,2),3),2),3(-2,1,2),6(-2,3))
*/