#include<bits/stdc++.h>
#define MAXN 2000007
using namespace std;

struct line{
    int from,to,id;

    inline friend bool operator < (line fr,line sc){
        return fr.to<sc.to;
    }
};

int n,x;
int a[MAXN],to[MAXN],jump[MAXN];

priority_queue<line> q;
vector< pair<int,long long> > tree[MAXN];

int cost(int x,int y){
    if(y==0)return 0;
    return min(y+a[y],n) - min(x+a[x],n);
}

void build_tree(){
    for(int i=1;i<=n;i++){
        q.push({max(1,i-a[i]),min(n,i+a[i]),i});
    }

    for(int i=n;i>=1;i--){
        while(!q.empty() and q.top().from>i+a[i]+1){
            q.pop();
        }
        
        if(i+a[i]>=n)to[i]=0;
        else to[i]=q.top().id;
    }

    for(int i=1;i<=n;i++){
        cout<<i<<" "<<to[i]<<" "<<cost(i,to[i])<<"\n";
        tree[to[i]].push_back({i,cost(i,to[i])});
    }

    while(!q.empty())q.pop();
    for(int i=1;i<=n;i++){
        q.push({max(1,i-a[i]),min(n,i+a[i]),i});
    }

    for(int i=n;i>=1;i--){
        while(!q.empty() and q.top().from>i){
            q.pop();
        }

        jump[i]=q.top().id;
    }

    for(int i=1;i<=n;i++){
        cout<<i+n<<" "<<jump[i]<<" "<<min(n,a[jump[i]]+jump[i])-(i-1)<<"\n";

        tree[jump[i]].push_back({n+i, min(n,a[jump[i]]+jump[i])-(i-1) });
    }
}

long long dist[MAXN],dep[MAXN],ans;

void dfs(int x,long long dep,long long sum,long long s){
    dist[x]=sum-(dep+1)*s;

    for(int i=0;i<tree[x].size();i++){
        dfs(tree[x][i].first,dep-1,sum+dep*tree[x][i].second,s+tree[x][i].second);
    }
}

int main(){

    cin>>n>>x;
    for(int i=1;i<=n;i++){
        cin>>a[i];
    }

    build_tree();
    dfs(0,n,0,0);

    for(int i=n+1;i<=2*n;i++){
        ans+=dist[i];
    }

    cout<<ans<<"\n";

    return 0;
}

/*
10 0
0 1 0 0 2 0 1 3 0 1

*/