#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=4e5+5;

mt19937 mt(32423);

int n;
int a[MAXN];
vector<int> adj[MAXN];
int lp[MAXN];
int cnt[MAXN];
int divs;
bool dvb[MAXN];
//int depth[MAXN];
int ans=0;

void sieve(int mx)
{
    lp[1]=1;
    for(int i=2;i<=mx;i++)
    {
        if(!lp[i])
        {
            lp[i]=i;
            if((long long)i*i>mx) continue;
            for(int j=i*i;j<=mx;j+=i)
            {
                lp[j]=i;
            }
        }
    }
}
/*
void dfs1(int v,int par)
{
    for(auto u: adj[v])
    {
        if(u==par) continue;
        depth[u]=depth[v]+1;
        dfs1(u,v);
    }
}*/

int dfs(int v,int par,int depth)
{
    int max1=0, max2=0;
    for(auto u: adj[v])
    {
        if(u==par) continue;
        int cur=dfs(u,v,depth+1);
        if(cur>max1)
        {
            max2=max1;
            max1=cur;
        }
        else if(cur>max2) max2=cur;
    }
    if(max1 && max2) ans=max(ans, max1+max2-2*depth);
    else if(max1 && dvb[a[v]]) ans=max(ans, max1-depth);
    if(max1==0 && dvb[a[v]]) max1=depth;
    return max1;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n;
for(int i=1;i<=n;i++) cin>>a[i];
for(int i=1;i<n;i++)
{
    int u,v;
    cin>>u>>v;
    adj[u].push_back(v);
    adj[v].push_back(u);
}

int mx=(*max_element(a+1,a+n+1));
sieve(mx);

for(int i=1;i<=n;i++)
{
    int x=a[i];
    while(x>1)
    {
        int d=lp[x];
        cnt[d]++;
        while(lp[x]==d) x/=d;
    }
}

int root=1;

//depth[root]=1;
//dfs1(root,0);

for(int i=2;i<=mx;i++)
{
    if(cnt[i]>1)
    {
        divs=i;
        for(int j=divs;j<=mx;j+=divs) dvb[j]=1;
        dfs(mt()%n+1,0,1);
        for(int j=divs;j<=mx;j+=divs) dvb[j]=0;
    }
}

cout<<ans<<endl;

return 0;
}
