#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 4*1e5+5;

int n,a[maxn];
vector<int>g[maxn];

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++) cin >> a[i];
    int x,y;
    for(int i = 1; i < n; i++)
    {
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
}

int sub[maxn],used[maxn],sz;
int dep[maxn],ans;

void dfs_sub(int beg, int par)
{
    sub[beg] = 1;
    for(int nb : g[beg])
    {
        if(nb==par||used[nb]) continue;
        dfs_sub(nb,beg);
        sub[beg] += sub[nb];
    }
}

int find_cen(int beg, int par)
{
    for(int nb : g[beg]) if(nb!=par&&!used[nb]&&sub[nb]>sz/2) return find_cen(nb,beg);
    return beg;
}

void break_del(int x, int put)
{
    int d = 2;
    while(d*d<x)
    {
        int br = 0;
        while(x%d==0)
        {
            x /= d;
            br++;
        }
        if(br) dep[d] = max(dep[d],put);
        d++;
    }
    if(d*d==x) dep[d] = max(dep[d],put);
    else dep[x] = max(dep[x],put);
}

void break_ans(int x, int put)
{
    int d = 2;
    while(d*d<x)
    {
        int br = 0;
        while(x%d==0)
        {
            x /= d;
            br++;
        }
        if(br&&dep[d]!=-1) ans = max(ans,dep[d]+put);
        d++;
    }
    if(d*d==x)
    {
        if(dep[d]!=-1) ans = max(ans,dep[d]+put);
    }
    else if(dep[x]!=-1) ans = max(ans,dep[x]+put);
}

void clear_dep(int x)
{
    int d = 2;
    while(d*d<x)
    {
        int br = 0;
        while(x%d==0)
        {
            x /= d;
            br++;
        }
        if(br) dep[d] = -1;
        d++;
    }
    if(d*d==x) dep[d] = -1;
    else dep[x] = -1;
}

int d;
bool f;

void dfs(int beg, int par)
{
    if(f) break_ans(a[beg],d);
    else break_del(a[beg],d);
    for(int nb : g[beg])
    {
        if(nb==par||used[nb]) continue;
        d++;
        dfs(nb,beg);
        d--;
    }
}

void dfs_clear(int beg, int par)
{
    clear_dep(a[beg]);
    for(int nb : g[beg])
    {
        if(nb==par||used[nb]) continue;
        dfs_clear(nb,beg);
    }
}

void dfs_cen(int beg, int par)
{
    dfs_sub(beg,beg);
    sz = sub[beg];
    int cen = find_cen(beg,beg);

    used[cen] = 1;

    break_del(a[cen],0);
    for(int nb : g[cen])
    {
        if(used[nb]) continue;
        f = true;
        d = 1;
        dfs(nb,nb);
        f = false;
        d = 1;
        dfs(nb,nb);
    }

    clear_dep(a[cen]);
    for(int nb : g[cen]) if(!used[nb]) dfs_clear(nb,nb);
    for(int nb : g[cen]) if(!used[nb]) dfs_cen(nb,cen);
}

void solve()
{
    memset(dep,-1,sizeof(dep));
    dfs_cen(1,1);
    cout << ans << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	read();
	solve();
return 0;
}
