#include<bits/stdc++.h>
#define MAXN 150007
using namespace std;

string s;
int level,num,last,mult,leaves;

vector< pair<int,int> > tree[20];
stack<int> st;

vector< vector< pair<int,int> > > equations;


bool cmp(vector< pair<int,int> > a,vector< pair<int,int> > b){
    return int(a.size()) < int(b.size());
}

vector<int> dfs2(int x){
    vector<int> res={};

    for(int i=0;i<tree[x].size();i++){
        if(tree[x][i].first<0){
            res.push_back(-tree[x][i].first);
        }

        if(tree[x][i].first>0){

            vector<int> z=dfs2(tree[x][i].first);
            for(int k:z)res.push_back(k);
        }
    }

    return res;
}

void dfs(int x){

    for(int i=0;i<tree[x].size();i++){
        if(tree[x][i].first>0)dfs(tree[x][i].first);
    }

    vector< pair<int,int> > curr;

    for(int i=0;i<tree[x].size();i++){
        if(tree[x][i].first<0){
            curr.push_back({-tree[x][i].first,tree[x][i].second});
        }else{
            vector<int> s=dfs2(tree[x][i].first);
            for(int k:s){
                curr.push_back({k,tree[x][i].second});
            }
        }
    }

    equations.push_back(curr);
}

int x[20],sol[20];
bool used[20];

bool brute(int pos);
bool brute2(int pos,int id,int sum);

bool brute(int pos){
    if(pos==equations.size()){
        for(int i=1;i<=leaves;i++)sol[i]=x[i];
        return true;
    }

    return brute2(pos,0,0);
}

bool brute2(int pos,int id,int sum){
    if(id==equations[pos].size()){
        if(sum==0)return brute(pos+1);
        else return false;
    }

    pair<int,int> c=equations[pos][id];

    if(x[c.first]!=0){
        return brute2(pos,id+1,sum+x[c.first]*c.second);
    }else{
        for(int i=1;i<=leaves;i++){
            if(used[i])continue;
            
            used[i]=true; x[c.first]=i;
            if(brute2(pos,id+1,sum+x[c.first]*c.second))return true;
            used[i]=false; x[c.first]=0;
        }
    }

    return false;
}

void printsol(int x){
    cout<<"(";

    for(int i=0;i<tree[x].size();i++){
        if(tree[x][i].first<0)cout<<sol[-tree[x][i].first];
        else printsol(tree[x][i].first);

        if(i<tree[x].size()-1)cout<<",";
    }

    cout<<")";
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>s;
    mult=1;

    for(int i=0;i<s.size();i++){
        if(s[i]=='-'){
            mult=-1;
        }else if(s[i]>='0' and s[i]<='9'){
            last*=10; last+=s[i]-'0';
        }else{
            if(s[i]==','){
                if(last!=0){
                    leaves++;

                    tree[st.top()].push_back({-leaves,last*mult});
                    last=0; mult=1;
                }
            }else if(s[i]=='('){
                num++;
                if(!st.empty()){
                    tree[st.top()].push_back({num,last*mult});
                }
                st.push(num);

                last=0; mult=1;
            }else if(s[i]==')'){
                if(last!=0){

                    leaves++;
                    tree[st.top()].push_back({-leaves,last*mult});
                    last=0; mult=1;
                }

                st.pop();
            }
        }
    }

    dfs(1);
    sort(equations.begin(),equations.end(),cmp);

    if(!brute(0)){
        cout<<1/0;
    }

    printsol(1);

    cout<<"\n";

    return 0;
}